/**************************************************************************

	CmdOpen

	main.c

	(C) Copyright 1996-2000 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/


/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef	_INC_OLE
#include <shlobj.h>				//SHBrowseForFolder

#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

#define APP_NAME			"CmdOpen Ver 0.0.2"

#define KEY_CMDOPEN			"exefile\\shell\\cmdopen"
#define KEY_COMMAND			"exefile\\shell\\cmdopen\\command"

#define MENU_NAME			"p[^w肵Ďs(&P)"

#define BUF_SIZE			256


/**************************************************************************
	Global Variables
**************************************************************************/

HINSTANCE g_hinst;


/**************************************************************************
	Local Function Prototypes
**************************************************************************/

static int GetReg(char *key, char *ret);
static BOOL SetReg(char *key, char *Setbuf);

static int FileSelect(HWND hDlg,char *ret);
static BOOL FolderSelect(HWND hWnd,char *ret);

static void InitDialog(HWND hDlg, char *FileName);
static void InfoExecFile(HWND hDlg);

static BOOL CALLBACK SetProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
static BOOL CALLBACK MainProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);


/******************************************************************************

	GetReg

	WXgɐݒ肳ꂽ擾

******************************************************************************/

static int GetReg(char *key, char *ret)
{
	HKEY hKey;
	DWORD dwType;
	long len;
	long rc;

	*ret = '\0';

	//WXgJ
	if(RegOpenKeyEx(HKEY_CLASSES_ROOT, key, 0, KEY_QUERY_VALUE, &hKey) != ERROR_SUCCESS){
		return 0;
	}

	//l擾
	len = BUF_SIZE;
	rc = RegQueryValueEx(hKey, NULL, NULL, &dwType, (LPBYTE)ret, &len);
	if(rc != ERROR_SUCCESS){
		RegCloseKey(hKey);
		return 0;
	}
	if(dwType != REG_SZ){
		RegCloseKey(hKey);
		return 0;
	}
	RegCloseKey(hKey);
	return 1;
}


/******************************************************************************

	SetReg

	WXgɕݒ肷

******************************************************************************/

static BOOL SetReg(char *key, char *Setbuf)
{
	HKEY hKey = NULL;
	long rc;
	BOOL ret = TRUE;

	//WXgL[쐬 or J
	if(RegCreateKey(HKEY_CLASSES_ROOT, key, &hKey) != ERROR_SUCCESS){
		return FALSE;
	}

	//lݒ肷
	rc = RegSetValueEx(hKey, NULL, 0, REG_SZ, (LPBYTE)Setbuf, lstrlen(Setbuf) + 1);
	if(rc != ERROR_SUCCESS){
		ret = FALSE;
	}
	RegCloseKey(hKey);
	return ret;
}


/******************************************************************************

	FileSelect

	t@CI

******************************************************************************/

static int FileSelect(HWND hDlg, char *ret)
{
	OPENFILENAME of;

	lstrcpy(ret,"*.*");
	ZeroMemory(&of, sizeof(OPENFILENAME));
	of.lStructSize = sizeof(OPENFILENAME);
	of.hwndOwner = hDlg;
	of.lpstrFilter = "ׂẴt@C (*.*)\0*.*\0\0";
	of.lpstrTitle = "t@CI";
	of.lpstrFile = ret;
	of.nMaxFile = BUF_SIZE - 1;
	of.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;

	//t@CI_CAO\
	if(GetOpenFileName((LPOPENFILENAME)&of) == TRUE){
		return of.nFilterIndex;
	}
	return -1;
}


/******************************************************************************

	FolderSelect

	tH_I

******************************************************************************/

static BOOL FolderSelect(HWND hWnd, char *ret)
{
	BROWSEINFO typBROWSEINFO;
	LPITEMIDLIST lpItemList;
	char buf[BUF_SIZE];

	typBROWSEINFO.hwndOwner = hWnd;
	typBROWSEINFO.pidlRoot = (const struct _ITEMIDLIST *)CSIDL_DESKTOP;
	strcpy(buf, "");
	typBROWSEINFO.pszDisplayName = buf;
	typBROWSEINFO.lpszTitle = "ƃtH_IĂ";
	typBROWSEINFO.ulFlags = BIF_RETURNONLYFSDIRS;	//tH_͑IłȂ悤ɂ
	typBROWSEINFO.lpfn = NULL;
	typBROWSEINFO.lParam = 0;
	typBROWSEINFO.iImage = 0;

	//tH_Iʂ\
	lpItemList = SHBrowseForFolder(&typBROWSEINFO);
	if(lpItemList == NULL){
		return FALSE;
	}
	//IĂtH_̃tpX擾
	SHGetPathFromIDList(lpItemList, ret);
	return TRUE;
}


/******************************************************************************

	InitDialog

	_CAO

******************************************************************************/

static void InitDialog(HWND hDlg, char *FileName)
{
	RECT DialogRect;
	HICON hIcon;
	char WorkDir[BUF_SIZE];
	char *p, *r;
	int x, y;

	//ACR
	hIcon = ExtractIcon(g_hinst, FileName, 0);
	SendDlgItemMessage(hDlg, IDC_STATIC_ICON, STM_SETICON, (WPARAM)hIcon, 0);

	//t@C
	SendDlgItemMessage(hDlg, IDC_EDIT_FILENAME, WM_SETTEXT, 0, (LPARAM)FileName);

	//R}hC
	SendDlgItemMessage(hDlg, IDC_EDIT_COMMANDLINE, EM_LIMITTEXT, (WPARAM)BUF_SIZE, 0);

	//ƃfBNg
	lstrcpy(WorkDir, FileName);
	r = p = WorkDir;
	while(*p != '\0'){
		if(IsDBCSLeadByte((BYTE)*p) == TRUE){
			p++;
		}else if(*p == '\\'){
			r = p + 1;
		}
		p++;
	}
	*r = '\0';
	SendDlgItemMessage(hDlg, IDC_EDIT_WORKDIR, WM_SETTEXT, 0, (LPARAM)WorkDir);
	SendDlgItemMessage(hDlg, IDC_EDIT_WORKDIR, EM_LIMITTEXT, (WPARAM)BUF_SIZE, 0);

	//s̑傫
	SendDlgItemMessage(hDlg, IDC_COMBO_SHOWWINDOW, CB_ADDSTRING, 0, (LPARAM)"ʏ̃EBhE");
	SendDlgItemMessage(hDlg, IDC_COMBO_SHOWWINDOW, CB_ADDSTRING, 0, (LPARAM)"ŏ");
	SendDlgItemMessage(hDlg, IDC_COMBO_SHOWWINDOW, CB_ADDSTRING, 0, (LPARAM)"ő剻");
	SendDlgItemMessage(hDlg, IDC_COMBO_SHOWWINDOW, CB_SETCURSEL, 0, 0);

	//EBhËʒuZ^O
	GetWindowRect(hDlg, &DialogRect);
	x = GetSystemMetrics(SM_CXSCREEN);
	y = GetSystemMetrics(SM_CYSCREEN);

	SetWindowPos(hDlg, 0,
		(x / 2) - ((DialogRect.right - DialogRect.left) / 2),
		(y / 2) - ((DialogRect.bottom - DialogRect.top) / 2),
		0, 0, SWP_NOACTIVATE | SWP_NOSIZE | SWP_NOZORDER);
	ShowWindow(hDlg, SW_RESTORE);
}


/******************************************************************************

	InfoExecFile

	_CAOɐݒ肳ꂽɃt@CN

******************************************************************************/

static void InfoExecFile(HWND hDlg)
{
	SHELLEXECUTEINFO sei;
	char FileName[BUF_SIZE];
	char CommandLine[BUF_SIZE];
	char WorkDir[BUF_SIZE];
	int i;

	//t@C
	SendDlgItemMessage(hDlg, IDC_EDIT_FILENAME, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)FileName);
	//R}hC
	SendDlgItemMessage(hDlg, IDC_EDIT_COMMANDLINE, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)CommandLine);
	//ƃfBNg
	SendDlgItemMessage(hDlg, IDC_EDIT_WORKDIR, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)WorkDir);

	//s̑傫
	i = SendDlgItemMessage(hDlg, IDC_COMBO_SHOWWINDOW, CB_GETCURSEL, 0, 0);
	switch(i)
	{
	case 0:
		sei.nShow = SW_SHOWNORMAL;
		break;

	case 1:
		sei.nShow = SW_SHOWMINIMIZED;
		break;

	case 2:
		sei.nShow = SW_SHOWMAXIMIZED;
		break;
	}
	sei.cbSize = sizeof(sei);
	sei.fMask = 0;
	sei.hwnd = NULL;
	sei.lpVerb = "open";
	sei.lpFile = FileName;
	sei.lpParameters = CommandLine;
	sei.lpDirectory = WorkDir;
	sei.hInstApp = g_hinst;

	//N
	ShellExecuteEx(&sei);
}


/******************************************************************************

	SetProc

	ݒ_CAO

******************************************************************************/

static BOOL CALLBACK SetProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	RECT DialogRect;
	char buf[BUF_SIZE], ret[BUF_SIZE];
	int i;
	int x, y;

	switch(uMsg)
	{
	case WM_INITDIALOG:
		//W[̃pX擾
		GetModuleFileName(g_hinst, buf, BUF_SIZE - 1);
		//WXgl擾
		i = GetReg(KEY_COMMAND, ret);

		//ɐݒ肳Ăꍇ̓`FbN{bNXɃ`FbN
		if(i == 1 && CompareString(MAKELCID(MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), SORT_DEFAULT),
			NORM_IGNORECASE, buf, lstrlen(buf), ret, lstrlen(buf)) == 2){
			SendDlgItemMessage(hDlg, IDC_CHECK_SETEXE, BM_SETCHECK, 1, 0);
		}

		//o[W
		SetWindowText(GetDlgItem(hDlg, IDC_STATIC_ABOUT), APP_NAME\
			"\n(C) Copyright 1999-2000 By Tomoaki Nakashima. All right reserved.\n\n"\
			"HOME PAGE : http://www.nakka.com/\nE-MAIL : nakka@nakka.com");

		//EBhËʒuZ^O
		GetWindowRect(hDlg, &DialogRect);
		x = GetSystemMetrics(SM_CXSCREEN);
		y = GetSystemMetrics(SM_CYSCREEN);

		SetWindowPos(hDlg, 0,
			(x / 2) - ((DialogRect.right - DialogRect.left) / 2),
			(y / 2) - ((DialogRect.bottom - DialogRect.top) / 2),
			0, 0, SWP_NOACTIVATE | SWP_NOSIZE | SWP_NOZORDER);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			if(SendDlgItemMessage(hDlg, IDC_CHECK_SETEXE, BM_GETCHECK, 0, 0) == 0){
				//WXgL[폜
				RegDeleteKey(HKEY_CLASSES_ROOT, KEY_COMMAND);
				RegDeleteKey(HKEY_CLASSES_ROOT, KEY_CMDOPEN);
			}else{
				//WXgɃj[ŕ\閼Oݒ肷
				if(SetReg(KEY_CMDOPEN, MENU_NAME) == FALSE){
					MessageBox(hDlg, "֘AtɎs܂B", APP_NAME, MB_ICONEXCLAMATION);
					break;
				}
				//WXgɃt@C̈ʒuƃt@Cݒ
				GetModuleFileName(g_hinst, buf, BUF_SIZE - 1);
				lstrcat(buf, " %1");
				if(SetReg(KEY_COMMAND, buf) == FALSE){
					MessageBox(hDlg, "֘AtɎs܂B", APP_NAME, MB_ICONEXCLAMATION);
					break;
				}
			}
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}



/******************************************************************************

	MainProc

	NIvVݒ_CAO

******************************************************************************/

static BOOL CALLBACK MainProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char buf[BUF_SIZE];

	switch(uMsg)
	{
	case WM_INITDIALOG:
		InitDialog(hDlg, (char *)lParam);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_DROPFILES:
		//hbvꂽt@CR}hCɐݒ肷
		DragQueryFile((HANDLE)wParam, 0, buf, BUF_SIZE - 1);
		SendDlgItemMessage(hDlg, IDC_EDIT_COMMANDLINE, EM_REPLACESEL, TRUE, (LPARAM)buf);
		SetFocus(GetDlgItem(hDlg, IDC_EDIT_COMMANDLINE));
		DragFinish((HANDLE)wParam);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		//t@CI
		case IDC_BUTTON_FILESELECT:
			if(FileSelect(hDlg, buf) == -1){
				 break;
			}
			SendDlgItemMessage(hDlg, IDC_EDIT_COMMANDLINE, EM_REPLACESEL, TRUE, (LPARAM)buf);
			SetFocus(GetDlgItem(hDlg, IDC_EDIT_COMMANDLINE));
			break;

		//tH_I
		case IDC_BUTTON_SELECTDIR:
			if(FolderSelect(hDlg, buf) == FALSE){
				 break;
			}
			SendDlgItemMessage(hDlg, IDC_EDIT_WORKDIR, WM_SETTEXT, 0, (LPARAM)buf);
			SetFocus(GetDlgItem(hDlg, IDC_EDIT_WORKDIR));
			break;

		//OK{^
		case IDOK:
			InfoExecFile(hDlg);

			EndDialog(hDlg, TRUE);
			break;

		//LZ{^
		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	WinMain

	main

******************************************************************************/

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int CmdShow)
{
	g_hinst = hInstance;

	if(lpCmdLine == NULL || *lpCmdLine == '\0'){
		//ݒ_CAO
		DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG_SET),
				NULL, SetProc, 0);
	}else{
		//NIvVݒ_CAO
		DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG_MAIN),
				NULL, MainProc, (LPARAM)lpCmdLine);
	}
	return 0;
}
